/**
 * Gate API v4
 * APIv4 provides spot, margin and futures trading operations. There are public APIs to retrieve the real-time market statistics, and private APIs which needs authentication to trade on user's behalf.
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.GateApi) {
      root.GateApi = {};
    }
    root.GateApi.InsuranceRecord = factory(root.GateApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';


  /**
   * The InsuranceRecord model module.
   * @module model/InsuranceRecord
   */

  /**
   * Constructs a new <code>InsuranceRecord</code>.
   * @alias module:model/InsuranceRecord
   * @class
   */
  var exports = function() {
    var _this = this;

  };

  /**
   * Constructs a <code>InsuranceRecord</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/InsuranceRecord} obj Optional instance to populate.
   * @return {module:model/InsuranceRecord} The populated <code>InsuranceRecord</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('t')) {
        obj['t'] = ApiClient.convertToType(data['t'], 'Number');
      }
      if (data.hasOwnProperty('b')) {
        obj['b'] = ApiClient.convertToType(data['b'], 'String');
      }
    }
    return obj;
  }

  /**
   * Unix timestamp in seconds
   * @member {Number} t
   */
  exports.prototype['t'] = undefined;
  /**
   * Insurance balance
   * @member {String} b
   */
  exports.prototype['b'] = undefined;



  return exports;
}));

